<script setup lang="ts">
import { ref } from "vue";
import { onMounted } from "vue";
import { useFoodStore } from "@/stores/food";
import { useQueueStore } from "@/stores/queue";
import type Orderitem from "@/types/Orderitem";
import type Queue from "@/types/Queue";

const foodStore = useFoodStore();
const queueStore = useQueueStore();
const table = ref(['']);
const x = ref(0);
const userString = localStorage.getItem("user");
const user = userString ? JSON.parse(userString) : null;
onMounted(async () => {
  queueStore.serve = await queueStore.getOrderToQueue("กำลังรอเสิร์ฟ");
  getTableOrder();
  console.log(table)
});


function getTableOrder() {
  table.value = [''];
  for (const item of queueStore.serve) {
    x.value = 0;
    for (const tables of table.value) {
      if (tables == '' + item.orderitem.order.table_id.type + item.orderitem.order.table_id.Number) {
        x.value = 1;
        break;
      }
    }
    if (x.value == 0) {
      table.value.push('' + item.orderitem.order.table_id.type + item.orderitem.order.table_id.Number)
    }
  }
}

async function Confirm(item: Queue) {
  foodStore.queueAdd.id = item.id
  foodStore.queueAdd.orderitem = item.orderitem.id!;
  foodStore.queueAdd.status = "เสิร์ฟสำเร็จ"
  foodStore.queueAdd.emp_serve = user.id;
  await foodStore.saveQueue();
  foodStore.clear();
  foodStore.confirmorder.id = item.orderitem.id
  foodStore.confirmorder.amount = item.orderitem.amount
  foodStore.confirmorder.order = '' + item.orderitem.order.id!
  foodStore.confirmorder.menu = item.orderitem.menu.id!
  foodStore.confirmorder.note = item.orderitem.note
  foodStore.confirmorder.numCancel = item.orderitem.numCancel;
  foodStore.confirmorder.numConfirm = item.orderitem.numConfirm+1;
  await foodStore.saveOrderlist();
  foodStore.clear();
  getLoop();
}

async function getLoop(){
  queueStore.serve = await queueStore.getOrderToQueue("กำลังรอเสิร์ฟ");
  getTableOrder();
}
setInterval(getLoop, 1000);
</script>

<template>
  <v-container fluid fill-height class="d-flex justify-center align-center">
    <v-row class="justify-center">
      <v-col>
        <v-card class="ma-5" color="#EEF2E6">
          <v-row class="justify-center">
            <v-card class="pa-5 ma-2 text-h4 text-center" width="100%" color="#1C6758"
              style="color: white;"><label>เสิร์ฟ</label></v-card>
          </v-row>
          <v-table v-for="wow of table" :key="wow" id="serve" style="padding-top: 10px;">
            <thead v-if="wow!=''">
              <tr>
                <th colspan="4" class="hth"><label class="htable">Table: {{ wow}}</label></th>
              </tr>
              <tr>
                <th width="40%">รายการอาหาร</th>
                <th>สถานะ</th>
                <th width="15%"></th>
              </tr>
            </thead>
            <tbody v-for="item in queueStore.serve" :key="item.id">
              <tr v-if="''+item.orderitem.order.table_id.type+item.orderitem.order.table_id.Number === wow">
                <td>{{ item.orderitem.menu.name }}</td>
                <td>{{ item.status }}</td>
                <td class="text-center">
                  <v-btn size="x-large" class="btng"
                    @click="Confirm(item)">SERVE</v-btn>
                </td>
              </tr>
            </tbody>
          </v-table>
        </v-card>
      </v-col>
    </v-row>
  </v-container>
</template>
<style scoped>
@import url("https://fonts.googleapis.com/css2?family=Noto+Sans+Thai:wght@100&display=swap");
label {
  font-family: "Noto Sans Thai", sans-serif;
  font-weight: bold;
  font-size: 48px !important;
}

.htable {
  font-family: "Noto Sans Thai", sans-serif;
  font-weight: bold;
  font-size: 32px !important;
}

.hth{
  background-color: #f15200;
}

th {
  font-family: "Noto Sans Thai", sans-serif;
  font-size: 24px !important;
  font-weight: bold !important;
  background-color: #1c6758;
}
td {
  font-family: "Noto Sans Thai", sans-serif;
  font-size: 22px !important;
  font-weight: bold;
}
#serve {
  border-collapse: collapse;
  width: 100%;
}

#serve td,
#serve th {
  padding: 10px;
  padding-left: 20px;
}

#serve th {
  padding-top: 12px;
  padding-bottom: 12px;
  text-align: left;
  color: white;
}

#serve tr {
  padding-top: 12px;
  padding-bottom: 12px;
  text-align: left;
  background-color: #ffefcf;
  color: black;
}

.btng {
  font-weight: bold;
  color: white;
  background-color: #00af91;
  width: 110px;
  font-size: 18px;
}

.btnr {
  font-weight: bold;
  color: white;
  background-color: #990000;
  width: 110px;
  font-size: 18px;
}
</style>